package jp.co.yaskawa.rtc.integratedMotion;
// -*- Java -*-
/*!
 * @file IntegratedMotion.java
 * @date $Date$
 *
 * $Id$
 */

import jp.go.aist.rtm.RTC.Manager;
import jp.go.aist.rtm.RTC.RTObject_impl;
import jp.go.aist.rtm.RTC.RtcDeleteFunc;
import jp.go.aist.rtm.RTC.RtcNewFunc;
import jp.go.aist.rtm.RTC.RegisterModuleFunc;
import jp.go.aist.rtm.RTC.util.Properties;

/*!
 * @class IntegratedMotion
 * @brief ${rtcParam.description}
 */
public class IntegratedMotion implements RtcNewFunc, RtcDeleteFunc, RegisterModuleFunc {

//  Module specification
//  <rtc-template block="module_spec">
    public static String component_conf[] = {
    	    "implementation_id", "IntegratedMotion",
    	    "type_name",         "IntegratedMotion",
    	    "description",       "${rtcParam.description}",
    	    "version",           "1.0.0",
    	    "vendor",            "YASKAWA",
    	    "category",          "Category",
    	    "activity_type",     "COMMUTATIVE",
    	    "max_instance",      "1",
    	    "language",          "Java",
    	    "lang_type",         "compile",
            // Configuration variables
            "conf.default.configFile", "default.conf",
            // Widget
            "conf.__widget__.configFile", "text",
            // Constraints
    	    ""
            };
//  </rtc-template>

    public RTObject_impl createRtc(Manager mgr) {
        return new IntegratedMotionImpl(mgr);
    }

    public void deleteRtc(RTObject_impl rtcBase) {
        rtcBase = null;
    }
    public void registerModule() {
        Properties prop = new Properties(component_conf);
        final Manager manager = Manager.instance();
        manager.registerFactory(prop, new IntegratedMotion(), new IntegratedMotion());
    }
}
