/**

  COPYRIGHT (c) 2010 Yaskawa Electric Corporation.
  
  $Revision: $
  $Author:   $
  $Date:     $
  
  Description:
  
 */
package jp.co.yaskawa.rtc.integratedMotion.module;

import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

/**
 * @author motohisa
 *
 */
public class Parameters {

    private Map<String, String> map_;
    
    Parameters() {
        map_ = new LinkedHashMap<String, String>();
    }
    
    public String get(String key) {
        return map_.get(key).toString();
    }
    
    public Set<String> keySet() {
        return map_.keySet();
    }
    
    public void put(String key, String v) {
        map_.put(key, v);
    }
    
    public double getJointAcceleration() {
        return Double.parseDouble(map_.get("joint.acceleration"));
    }
    
    public void putJointAcceleration(double v) {
        map_.put("joint.acceleration", String.valueOf(v));
    }
    
    public void setNumberOfJoint(int n) {
        map_.put("nJoint", String.valueOf(n));
    }
    
    public int getNumberOfJoint() {
        return Integer.parseInt(map_.get("nJoint"));
    }
    
    public void setNumberOfPosture(int n) {
        map_.put("nPosture", String.valueOf(n));
    }
    
    public int getNumberOfPosture() {
        return Integer.parseInt(map_.get("nPosture"));
    }
    
    public void putInt(String key, int i) {
        map_.put(key, String.valueOf(i));
    }
    
    public Integer getInt(String key) throws NumberFormatException {
        Object o = map_.get(key);
        if (o == null) {
            return null;
        }
        if (o instanceof Integer) {
            return (Integer)o;
        }
        Integer i = Integer.parseInt(map_.get(key).toString());
        return i;
    }
    
    public void putDouble(String key, double d) {
        map_.put(key, String.valueOf(d));
    }
    
    public Double getDouble(String key) throws NumberFormatException {
        Object o = map_.get(key);
        if (o == null) {
            return null;
        }
        if (o instanceof Double) {
            return (Double)o;
        }
        Double d = Double.parseDouble(map_.get(key).toString());

        return d;
    }
    
    public void putBool(String key, boolean b) {
        map_.put(key, String.valueOf(b));
    }
    
    public Boolean getBool(String key) {
        Object o = map_.get(key);
        if (o == null) {
            return null;
        }
        if (o instanceof Boolean) {
            return (Boolean)o;
        }
        Boolean b = Boolean.parseBoolean(map_.get(key).toString());
        return b;
    }
	
	
}
