/**
 * 
 */
package jp.co.yaskawa.rtc.integratedMotion.module;

/**
 * @author motohisa
 *
 */

import jp.co.yaskawa.rtc.integratedMotion.controller.*;

public interface UnitOperation {
	ReturnID abort();
	  ReturnID clearAlarms ();
	  ReturnID getActiveAlarm (AlarmSeqHolder alarms);
	  ReturnID getFeedbackPosCartesian (RightLeft type, FrameType frameType, CarPosWithElbowHolder pos);
	  ReturnID getFeedbackPosJoint (UnitType type, double[] pos);
	  ReturnID getState (org.omg.CORBA.IntHolder statusId, org.omg.CORBA.StringHolder message);
	  ReturnID getVersion (org.omg.CORBA.StringHolder version);
	  boolean isMoving ();
	  boolean isServoOn ();
	  ReturnID pause ();
	  ReturnID resetOriginalFrame ();
	  ReturnID resume ();
	  ReturnID selectRedundantAxes (RedundantAxesMask redundancy);
	  ReturnID selectRedundantLimit (RedundantLimit limit);
	  ReturnID servoOff ();
	  ReturnID servoOn ();
	  ReturnID setControlPointOffset (RightLeft type, double[][] offset);
	  ReturnID setJogTimeout (int time);
	  ReturnID stop ();
	  ReturnID selectMode (short mode, RightLeft type, boolean isHoldOtherArm);	  
	  ReturnID setJointCommand(UnitType type, double[] jointPos);
	  ReturnID setCartesianCommand(double[] cartesianPos);
	  ReturnID setRedundantCommand(double[] redundantPos);
	  ReturnID getRedundantPos(double[] redPos);
	  ReturnID getIKinematicsResult(double[] ikinema);
	  
}
