/**

  COPYRIGHT (c) 2010 Yaskawa Electric Corporation.
  
  $Revision: $
  $Author:   $
  $Date:     $
  
  Description:
  モーションクラスのインターフェース
  
 */
package jp.co.yaskawa.rtc.integratedMotion.module.motion;

import jp.co.yaskawa.rtc.integratedMotion.module.state.RTEmuContext;

/**
 * @author motohisa
 *
 */
public interface DoMotion<T> {
	
	/*
	 * 周期実行処理
	 * 
	 * @param c ステートコンテキスト
	 * @throws MotionAlarmException
	 */
	public void doSegment(RTEmuContext<T> c) throws MotionAlarmException ;
	
	/*
	 * モーションコマンドセット
	 * 
	 * @param c コマンドオブジェクト
	 */
	public void setCommand(UnitCommand<T> c);
	
	/*
	 * 動作中判定
	 */
	public boolean isMoving();
	
	
}
