/**
 * 
 */
package jp.co.yaskawa.rtc.integratedMotion.module.motion;

import jp.co.yaskawa.rtc.integratedMotion.controller.UnitType;
import jp.co.yaskawa.rtc.integratedMotion.module.IntegratedMotionInterpolator;
import jp.co.yaskawa.rtc.integratedMotion.module.RTMath;

/**
 * @author motohisa
 *
 */
public class MoveUnitRel<T> extends MoveUnitAbs<T> {
	
	public MoveUnitRel(IntegratedMotionInterpolator u, T type) {
		super(u,type);
	}
		
	public void setCommand(UnitCommand<T> c) {
    	System.out.println("MoveUnitRel: setCommand");
		segmentPeriod_ = unit_.getSegmentPeriod();
   	
        int jointNum = 7;

        double[] params = c.getParams();
        if(params[0] == 1.0) {
        	unitType_ = UnitType.RIGHT_ARM;
        	jointNum = 7;
        }
        if(params[0] == 2.0) {
        	unitType_ = UnitType.LEFT_ARM;
        	jointNum = 7;
        }
        if(params[0] == 3.0) {
        	unitType_ = UnitType.LUMBER;
        	jointNum = 3;
        }
        if(params[0] == 4.0) {
        	unitType_ = UnitType.VEHICLE;
        	jointNum = 3;
        }
          	
    	currentAngleArray_ = new double[jointNum];
        unit_.getFeedbackPosJoint(unitType_, currentAngleArray_);
        
        targetAngleArray_ = new double[jointNum];        
        deltaAngleArray_ = new double[jointNum];
        absDeltaAngleArray_ = new double[jointNum];
    	
        for (int i = 0; i < jointNum; i++) {
        	targetAngleArray_[i] = currentAngleArray_[i] + params[i+1];
            deltaAngleArray_[i] = params[i+1];
            absDeltaAngleArray_[i] = Math.abs(deltaAngleArray_[i]);
        }
        
        targetVelocity_ = params[jointNum+1];
        accel_ = params[jointNum+2];

        double maxAbsoluteAngle = RTMath.max(absDeltaAngleArray_.clone());
        axisNumMaxDistance_ = RTMath.getIndex(maxAbsoluteAngle, absDeltaAngleArray_);
        targetAngle_ = targetAngleArray_[axisNumMaxDistance_];
        
        ratioArray_ = new double[jointNum];
        for (int i = 0; i < ratioArray_.length; i++) {
            ratioArray_[i] = deltaAngleArray_[i] / absDeltaAngleArray_[axisNumMaxDistance_];
        }
        
        isMoving_ = true;
        
        if (true) {
        	System.out.println("SegmentPeriod: " + segmentPeriod_);
        	System.out.println("Currnet");
        	System.out.print("\t");
        	for (int i = 0; i < currentAngleArray_.length; i++) {
        		System.out.print(currentAngleArray_[i] + " ");
        	}
        	System.out.println();
        	System.out.println("Target");
        	System.out.print("\t");
        	for (int i = 0; i < targetAngleArray_.length; i++) {
        		System.out.print(targetAngleArray_[i] + " ");
        	}
        	System.out.println();
        	System.out.println("target velocity: " + targetVelocity_ + " accel: " + accel_ );
        	System.out.println("MaxAngle: " + maxAbsoluteAngle + " axis index: " + axisNumMaxDistance_);
        }

	}

}
